Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::RSA_PublicKey Class Reference

`#include <rsa.h>`

Inheritance diagram for Botan::RSA_PublicKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool) const override
std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
size_t | estimated_strength () const override
const BigInt & | get_e () const
const BigInt & | get_n () const
virtual OID | get_oid () const
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
std::vector< uint8_t > | public_key_bits () const override
| RSA_PublicKey (const AlgorithmIdentifier &alg_id, const std::vector< uint8_t > &key_bits)
| RSA_PublicKey (const BigInt &n, const BigInt &e)
std::vector< uint8_t > | subject_public_key () const

## Protected Member Functions
| RSA_PublicKey ()=default

## Protected Attributes
BigInt | m_e
BigInt | m_n

## Detailed Description

RSA Public Key

Definition at line 19 of file rsa.h.

## Constructor & Destructor Documentation

Botan::RSA_PublicKey::RSA_PublicKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const std::vector< uint8_t > & | key_bits
| ) |  |

Load a public key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | DER encoded public key bits

Definition at line 54 of file rsa.cpp.

References Botan::BER_Decoder::decode(), Botan::BER_Decoder::end_cons(), m_e, m_n, Botan::SEQUENCE, and Botan::BER_Decoder::start_cons().

56 {
57 BER_Decoder(key_bits)
58 .start_cons(SEQUENCE)
59 .decode(m_n)
60 .decode(m_e)
61 .end_cons();
62 }
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

Botan::RSA_PublicKey::RSA_PublicKey | ( | const BigInt & | n,
|  | const BigInt & | e
| ) |  |
| inline

Create a public key.

- n the modulus
- e the exponent

Definition at line 35 of file rsa.h.

35 :
36 m_n(n), m_e(e) {}
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

Botan::RSA_PublicKey::RSA_PublicKey | ( |  | ) |
| protected default

## Member Function Documentation

std::string Botan::RSA_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 38 of file rsa.h.

Referenced by Botan::RSA_PrivateKey::create_decryption_op(), create_encryption_op(), Botan::RSA_PrivateKey::create_kem_decryption_op(), create_kem_encryption_op(), Botan::RSA_PrivateKey::create_signature_op(), create_verification_op(), and Botan::RSA_PrivateKey::RSA_PrivateKey().

38 { return "RSA"; }

AlgorithmIdentifier Botan::RSA_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 38 of file rsa.cpp.

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_NULL_PARAM.

39 {
40 return AlgorithmIdentifier(get_oid(),
41 AlgorithmIdentifier::USE_NULL_PARAM);
42 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:30
Botan::AlgorithmIdentifier::USE_NULL_PARAM
Definition: alg_id.h:23

bool Botan::RSA_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Reimplemented in Botan::RSA_PrivateKey.

Definition at line 67 of file rsa.cpp.

References Botan::BigInt::is_even(), m_e, and m_n.

68 {
69 if(m_n < 35 || m_n.is_even() || m_e < 2)
70 return false;
71 return true;
72 }
Botan::BigInt::is_even
bool is_even() const
Definition: bigint.h:232
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

std::unique_ptr< PK_Ops::Encryption > Botan::RSA_PublicKey::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 407 of file rsa.cpp.

References algo_name(), and Botan::Exception::what().

410 {
411 #if defined(BOTAN_HAS_OPENSSL)
412 if(provider == "openssl" || provider.empty())
413 {
414 try
415 {
416 return make_openssl_rsa_enc_op(*this, params);
417 }
418 catch(Exception& e)
419 {
420 /*
421 * If OpenSSL for some reason could not handle this (eg due to OAEP params),
422 * throw if openssl was specifically requested but otherwise just fall back
423 * to the normal version.
424 */
425 if(provider == "openssl")
426 throw Exception("OpenSSL RSA provider rejected key:", e.what());
427 }
428 }
429 #endif
430
431 if(provider == "base" || provider.empty())
432 return std::unique_ptr<PK_Ops::Encryption>(new RSA_Encryption_Operation(*this, params));
433 throw Provider_Not_Found(algo_name(), provider);
434 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::RSA_PublicKey::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 437 of file rsa.cpp.

References algo_name().

440 {
441 if(provider == "base" || provider.empty())
442 return std::unique_ptr<PK_Ops::KEM_Encryption>(new RSA_KEM_Encryption_Operation(*this, params));
443 throw Provider_Not_Found(algo_name(), provider);
444 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

std::unique_ptr< PK_Ops::Verification > Botan::RSA_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 447 of file rsa.cpp.

References algo_name().

449 {
450 #if defined(BOTAN_HAS_OPENSSL)
451 if(provider == "openssl" || provider.empty())
452 {
453 std::unique_ptr<PK_Ops::Verification> res = make_openssl_rsa_ver_op(*this, params);
454 if(res)
455 return res;
456 }
457 #endif
458
459 if(provider == "base" || provider.empty())
460 return std::unique_ptr<PK_Ops::Verification>(new RSA_Verify_Operation(*this, params));
461
462 throw Provider_Not_Found(algo_name(), provider);
463 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:38

size_t Botan::RSA_PublicKey::estimated_strength | ( |  | ) | const
| override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 33 of file rsa.cpp.

References Botan::if_work_factor(), and key_length().

34 {
35 return if_work_factor(key_length());
36 }
Botan::RSA_PublicKey::key_length
size_t key_length() const override
Definition: rsa.cpp:28
Botan::if_work_factor
size_t if_work_factor(size_t bits)
Definition: workfactor.cpp:19

const BigInt& Botan::RSA_PublicKey::get_e | ( |  | ) | const
| inline

Returns
  public exponent

Definition at line 54 of file rsa.h.

54 { return m_e; }
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76

const BigInt& Botan::RSA_PublicKey::get_n | ( |  | ) | const
| inline

Returns
  public modulus

Definition at line 49 of file rsa.h.

References m_n.

49 { return m_n; }
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 30 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), and Botan::OIDS::lookup().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::TPM_PrivateKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

31 {
32 try {
33 return OIDS::lookup(algo_name());
34 }
35 catch(Lookup_Error&)
36 {
37 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
38 }
39 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:18

size_t Botan::RSA_PublicKey::key_length | ( |  | ) | const
| override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 28 of file rsa.cpp.

References Botan::BigInt::bits(), and m_n.

Referenced by estimated_strength().

29 {
30 return m_n.bits();
31 }
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:184
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 114 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

114 { return 0; }

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 103 of file pk_keys.h.

Referenced by Botan::X509_Object::check_signature(), Botan::choose_sig_format(), Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

103 { return 1; }

std::vector< uint8_t > Botan::RSA_PublicKey::public_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 44 of file rsa.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents_unlocked(), m_e, m_n, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

45 {
46 return DER_Encoder()
47 .start_cons(SEQUENCE)
48 .encode(m_n)
49 .encode(m_e)
50 .end_cons()
51 .get_contents_unlocked();
52 }
Botan::RSA_PublicKey::m_e
BigInt m_e
Definition: rsa.h:76
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::RSA_PublicKey::m_n
BigInt m_n
Definition: rsa.h:76

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 17 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents_unlocked(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), and Botan::X509::PEM_encode().

18 {
19 return DER_Encoder()
20 .start_cons(SEQUENCE)
21 .encode(algorithm_identifier())
22 .encode(public_key_bits(), BIT_STRING)
23 .end_cons()
24 .get_contents_unlocked();
25 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34

## Member Data Documentation

BigInt Botan::RSA_PublicKey::m_e
| protected

Definition at line 76 of file rsa.h.

Referenced by check_key(), Botan::RSA_PrivateKey::check_key(), Botan::RSA_PrivateKey::private_key_bits(), public_key_bits(), Botan::RSA_PrivateKey::RSA_PrivateKey(), and RSA_PublicKey().

BigInt Botan::RSA_PublicKey::m_n
| protected

Definition at line 76 of file rsa.h.

Referenced by check_key(), Botan::RSA_PrivateKey::check_key(), key_length(), Botan::RSA_PrivateKey::private_key_bits(), public_key_bits(), Botan::RSA_PrivateKey::RSA_PrivateKey(), and RSA_PublicKey().

The documentation for this class was generated from the following files:

- src/lib/pubkey/rsa/rsa.h
- src/lib/pubkey/rsa/rsa.cpp